unit HTMLReportExeProtocol;

interface

uses
  AxCtrls, ActiveX, Urlmon, Windows, Classes, ComObj,SysUtils;


type
  THTMLReportprotocol = class(TComObject, IInternetProtocol)
  protected
    DataStream: IStream;
    TotalSize: Integer;
    Written: Integer;
    function Start(szUrl: LPCWSTR; OIProtSink: IInternetProtocolSink;
      OIBindInfo: IInternetBindInfo; grfPI, dwReserved: DWORD): HResult; stdcall;
    function Continue(const ProtocolData: TProtocolData): HResult; stdcall;
    function Abort(hrReason: HResult; dwOptions: DWORD): HResult; stdcall;
    function Terminate(dwOptions: DWORD): HResult; stdcall;
    function Suspend: HResult; stdcall;
    function Resume: HResult; stdcall;

    function Read(pv: Pointer; cb: ULONG; out cbRead: ULONG): HResult; stdcall;
    function Seek(dlibMove: LARGE_INTEGER; dwOrigin: DWORD; out libNewPosition: ULARGE_INTEGER): HResult; stdcall;
    function LockRequest(dwOptions: DWORD): HResult; stdcall;
    function UnlockRequest: HResult; stdcall;

  end;


procedure RegisterHTMLReportProtocol;
procedure UnRegisterHTMLReportProtocol;


const
  Class_HTMLReportProtocol: TGUID = '{29022892-A073-46A0-AA00-C57B88614E74}';


implementation

uses ComServ, Unit1;

{ THTMLReportProtocol }

var
  hModule: HInst;
  Factory: IClassFactory;
  InternetSession: IInternetSession;


procedure RegisterHTMLReportProtocol;
begin
  CoGetClassObject(Class_HTMLReportProtocol, CLSCTX_SERVER, nil, IClassFactory, Factory);
  CoInternetGetSession(0, InternetSession, 0);
  InternetSession.RegisterNameSpace(Factory, Class_HTMLReportProtocol, 'HTMLReport', 0, nil, 0);
end;

procedure UnRegisterHTMLReportProtocol;
begin
  InternetSession.UnregisterNameSpace(Factory, 'HTMLReport');
end;



function THTMLReportProtocol.Start(szUrl: LPCWSTR; OIProtSink: IInternetProtocolSink;
  OIBindInfo: IInternetBindInfo; grfPI, dwReserved: DWORD): HResult;
var
  Url,nam: string;
  h2: HInst;
  Data: Pointer;
  Dummy: Int64;
begin
  Totalsize := 0;
  written := 0;
  url := (Copy(szurl, Pos(':', SzUrl) + 1, 255));
  url:=reportcreate(url);
  Totalsize:=length(url);
  CreateStreamOnHGlobal(0, True, DataStream);
  TOleStream.Create(DataStream).WriteBuffer(url[1], TotalSize);
  DataStream.Seek(0, STREAM_SEEK_SET, Dummy);
  OIProtSink.ReportData(BSCF_FIRSTDATANOTIFICATION or
       BSCF_LASTDATANOTIFICATION or BSCF_DATAFULLYAVAILABLE,TotalSize,TotalSize);
  Result:=OIProtSink.ReportResult(S_OK, 0, nil);
end;

function THTMLReportProtocol.Read(pv: Pointer; cb: ULONG; out cbRead: ULONG): HResult;
begin
  DataStream.Read(pv, cb, @cbRead);
  Inc(written, cbread);
  if (written = totalSize) then
    result := S_FALSE else Result := E_PENDING;
end;


function THTMLReportProtocol.Abort(hrReason: HResult; dwOptions: DWORD): HResult;
begin
  Result := S_OK;
end;

function THTMLReportProtocol.Continue(const ProtocolData: TProtocolData): HResult;
begin
  Result := S_OK;
end;

function THTMLReportProtocol.LockRequest(dwOptions: DWORD): HResult;
begin
  Result := S_OK;
end;


function THTMLReportProtocol.Resume: HResult;
begin
  Result := S_OK;
end;

function THTMLReportProtocol.Seek(dlibMove: LARGE_INTEGER; dwOrigin: DWORD;
  out libNewPosition: ULARGE_INTEGER): HResult;
begin
  Result := S_OK;
end;

function THTMLReportProtocol.Suspend: HResult;
begin
  Result := S_OK;
end;

function THTMLReportProtocol.Terminate(dwOptions: DWORD): HResult;
begin
  result := S_OK;
end;

function THTMLReportProtocol.UnlockRequest: HResult;
begin
  Result := S_OK;
end;


initialization

  TComObjectFactory.Create(ComServer, THTMLReportProtocol, Class_HTMLReportProtocol,
    'HTMLReportProtocol', '', ciMultiInstance, tmApartment);

end.


